# Support and Subscription

Pigsty is a ready-to-use PostgreSQL database distribution, a local-first alternative to RDS/cloud database services, allowing users to run a fully-featured local RDS service at a hardware cost of just a few core months. The software itself is completely open-source and free. If it has helped you, please consider [sponsoring us](#sponsorship).

Although Pigsty is designed to replace manual database operations with database autopilot software, even the best software can only solve some problems. There will always be some infrequent issues and various problems not limited to technology that require expert intervention. Therefore, we also offer professional [service subscriptions](#service-subscription).


------------------

## Sponsorship

Pigsty is a free & open-source software nurtured by the passion of PostgreSQL community members.

If our work has helped you, please consider sponsoring or supporting our project. Every penny counts, and advertisements are also a form of support:

- Donate to us:  [Aifadian](https://afdian.net/a/pigsty).
- Share your experiences and use cases of Pigsty through articles, lectures, and videos.
- Allow us to mention your organization in "These users who use Pigsty"
- Nominate/Recommend our project and services to your friends, colleagues, and clients in need.
- Follow our [WeChat Column](https://mp.weixin.qq.com/s/-E_-HZ7LvOze5lmzy3QbQA) and share technical articles with your friends.

The Pigsty community already offers free WeChat/Discord/Telegram Q&A Office Hours, and we are also happy to provide more free value-added services to our supporters.

WeChat: Search `pigsty-cc` and join the User Group.

Telegram: https://t.me/joinchat/gV9zfZraNPM3YjFh

Discord: https://discord.gg/Mu2b6Wxr


------------------

## Service Subscription

If you have the following needs, please consider our **professional services subscription**.

- Running databases in critical scenarios and needing strict SLA guarantees.
- Seeking backup for Pigsty and PostgreSQL-related issues.
- Wanting guidance on best practices for PostgreSQL/Pigsty production environments.
- Needing experts to help interpret monitoring charts, analyze and locate performance bottlenecks and fault root causes, and provide opinions.
- Planning a database architecture that meets security, disaster recovery, and compliance requirements based on existing resources and business needs.
- Needing to migrate other databases to PostgreSQL, or migrate and transform legacy instances.
- Building an observability system, data dashboard, and visualization application based on the Prometheus/Grafana tech stack.
- Seeking support for domestic trusted operating systems/domestic trusted ARM chip architectures and providing Chinese/localized interface support.
- Moving off the cloud and seeking an open-source alternative to RDS for PostgreSQL - a cloud-neutral, vendor-lock-in-free solution.
- Seeking professional technical support for Redis/ETCD/MinIO/Greenplum/Citus/TimescaleDB.
- Wanting to avoid the restrictions of the AGPL v3 license of Pigsty itself, doing derivative works being forced to use the same open-source license for secondary development and branding.
- Consider selling Pigsty as SaaS/PaaS/DBaaS or providing technical services/consulting services based on this distribution.

Service subscriptions are divided into two different levels, **Standard Service Agreement,** and **Enterprise Service Agreement**, as shown in the table below:

|       Agreement/Plan       |                  AGPLv3 Open Source License                  |                  Standard Service Agreement                  |                 Enterprise Service Agreement                 |
| :------------------------: | :----------------------------------------------------------: | :----------------------------------------------------------: | :----------------------------------------------------------: |
|        Description         | Designed for users and developers who comply with the AGPLv3 open-source license and are fully self-sufficient | Designed for users who are mostly self-sufficient but want direct support from Pigsty and backup for complex issues | Designed for scenarios that require strict SLAs and maximum support for critical tasks |
|       Version Range        |                       Current version                        |   Versions released within the last year and LTS versions    |         Versions released within the last five years         |
|       Support Method       |                   WeChat group public Q&A                    |         Remote desktop / WeChat <br /> Phone / Email         | Remote desktop / WeChat / Phone /<br /> Email / On-site / On-site* |
|   Language and Interface   |                           English                            |                        + Localization                        |                        + Localization                        |
|           Price            |                             Free                             |     10 \$ / core·month or <br/> 100 \$ / instance·month      |     20 \$ / core·month or <br/> 200 \$ / instance·month      |
|       Starting Price       |                                                              |                        5,000 $ / year                        |                       10,000 $ / year                        |
|        Expert Days         |                                                              |      One expert day for every 2,000 $ subscription fee       |      One expert day for every 2,000 $ subscription fee       |
|            SLA             |                                                              |                  Respond within < 48 hours                   |                   Respond within < 2 hours                   |
|         Time Range         |                                                              |                 8 x 5 (local business hour)                  |                            7 x 24                            |
|   Performance Diagnosis    |                                                              |                      ✅ Unlimited times                       |                      ✅ Unlimited times                       |
|        Panic Button        |                                                              |                        ✅ Once a year                         |                      ✅ Unlimited times                       |
|      Upgrade Guidance      |                                                              |                        ✅ Once a year                         |                      ✅ Unlimited times                       |
| Annual Architecture Review |                                                              |                                                              |                        ✅ Once a year                         |
| Annual Performance Review  |                                                              |                                                              |                        ✅ Once a year                         |

- Billing is based on CPU core or instance count, using $/(core·month) as the unit. Instances exceeding ten cores are counted as ten cores.
- Subscriptions include limited expert days, which can be used for training, consulting, planning, upgrade guidance, fault analysis, troubleshooting, production check-ups, and teaching training.
- Normal service support is provided via remote desktop/phone/Slack/Discord/email/Zoom. On-site support requires additional travel expenses, and the standard is based on the contract.
- The final price will be adjusted based on the self-sufficiency of your A team, and scale, scope, work time, and content will also be considered. Please refer to the contract.
- We will do our best to provide feasible suggestions and solutions. If the consultation problem is not resolved, the fee will be reduced at our discretion. The specific SLA is based on the contract.

> Check [Vantage](https://instances.vantage.sh/) for realtime cloud RDS price.

Commercial support contact: Email: [rh@vonng.com](mailto:rh@vonng.com), WeChat: pigsty-cc / RuohangFeng


------------------

## Miscellaneous

We offer retail expert days that can be used for failure analysis, post-mortem, troubleshooting, performance analysis, problem-solving, teaching, and training, which can be purchased as needed.

- Top Expert: 20,000 ¥ / day (Top database experts with over ten years of experience, PCM/ACE, P9+)
- Senior Expert: 15,000 ¥ / day (Database experts with 5-10 years of experience, P8+/ICT4+)
- Technical Expert: 10,000 ¥ / day (P7+)

We offer teaching and training services on PostgreSQL, priced as follows:

- PostgreSQL Application Development: 20,000 ¥ / 1 day, up to 20 people.
- PostgreSQL Operations Management: 20,000 ¥ / 1 day, up to 20 people.
- PostgreSQL Kernel Architecture: 35,000 ¥ / 1 day, up to 10 people.

We offer deployment consulting and troubleshooting services, priced as follows:

- Deployment Consulting: 1000¥ / case, planning a deployment solution based on your existing resources and needs.
- Small Cases: 5000¥ / case, solving a non-urgent fault case, not exceeding half a working day, remote only.
- Large Cases include production fault recovery, data deletion recovery, and price negotiable.

Other services we offer include:

- On-site DBA: Only available for large-scale subscription customers.
- Custom Features: Database kernel modification / OS chip architecture adaptation / RDS service OEM branding.
- Projects: Database system/data warehouse, observability, data analysis/data visualization related projects.